function SM_missionList::onSelect(%this, %row)
{
	%image = getField(SM_missionList.getRowTextById(%row), 2);
	Map_Preview.setBitmap(%image);
	Map_Description.setText(getField(SM_missionList.getRowTextById(%row), 3));
}

function startMissionGui::onWake(%this)
{
	SM_missionList.clear();
	%i = 0;
	for(%file = findFirstFile($Server::MissionFileSpec); %file !$= ""; %file = findNextFile($Server::MissionFileSpec))
      if (strStr(%file, "/CVS/") == -1)
      {
         %mi = getMissionDisplayName(%file);

	 %desc = %mi.desc[0];
	 for(%d = 1; %d < %mi.desclines; %d++)
		%desc = %desc @ " " @ %mi.desc[%d];

         SM_missionList.addRow(%i++, %mi.name @ "\t" @ %file @ "\t" @ %mi.preview @ "\t" @ %desc);
	 %mi.delete();
      }
   SM_missionList.sort(0);
   SM_missionList.setSelectedRow(0);
   SM_missionList.scrollVisible(0);

	//load the saved server prefs
	TxtServerName.setValue($Pref::Server::Name);
	TxtServerInfo.setValue($Pref::Server::Info);
    TxtServerPort.setValue($Pref::Server::Port);
    TxtServerTimeLimit.setValue($Pref::Server::TimeLimit);
	TxtServerPassword.setValue($Pref::Server::Password);
	TxtServerAdminPassword.setValue($Pref::Server::AdminPassword);

	SliderNumPlayers.setValue($Pref::Server::MaxPlayers);
}

function startMissionGui::onSleep(%this)
{
	//save the server prefs from the screen
	//will this work? we might have started the server by the time this gets called.
	//UPDATE: nope, it doesnt
		
	
}

//----------------------------------------
function SM_StartMission()
{
	//save the pref values
	$Pref::Server::Name = TxtServerName.getValue();
	$Pref::Server::Info = TxtServerInfo.getValue();
    $Pref::Server::Port = TxtServerPort.getValue();
	$Pref::Server::TimeLimit = TxtServerTimeLimit.getValue();
	$Pref::Server::Password = TxtServerPassword.getValue();
	$Pref::Server::AdminPassword = TxtServerAdminPassword.getValue();
	$Pref::Server::MaxPlayers = SliderNumPlayers.getValue();

	//set your join password so you can join your own server
	$Client::Password = TxtServerPassword.getValue();


   %id = SM_missionList.getSelectedId();
   %mission = getField(SM_missionList.getRowTextById(%id), 1);

   if ($pref::HostMultiPlayer)
      %serverType = "MultiPlayer";
   else
      %serverType = "SinglePlayer";

   createServer(%serverType, %mission);
   %conn = new GameConnection(ServerConnection);
   RootGroup.add(ServerConnection);
   %conn.setConnectArgs($pref::Player::Name);
   %conn.setJoinPassword($Client::Password);
	error("-----------CONN = ", %conn);
   %conn.connectLocal();
}

//----------------------------------------
function getMissionDisplayName( %missionFile )
{
   %file = new FileObject();

   %MissionInfoObject = "";

   if ( %file.openForRead( %missionFile ) ) {
		%inInfoBlock = false;

		while ( !%file.isEOF() ) {
			%line = %file.readLine();
			%line = trim( %line );

			if( %line $= "new ScriptObject(MissionInfo) {" )
				%inInfoBlock = true;
			else if( %inInfoBlock && %line $= "};" ) {
				%inInfoBlock = false;
				%MissionInfoObject = %MissionInfoObject @ %line;
				break;
			}

			if( %inInfoBlock )
			   %MissionInfoObject = %MissionInfoObject @ %line @ " ";
		}

		%file.close();
	}
	%MissionInfoObject = "%MissionInfoObject = " @ %MissionInfoObject;
	eval( %MissionInfoObject );

   %file.delete();

   if( %MissionInfoObject.name !$= "" )
   {
      if( %MissionInfoObject.desc0 $= "" )
         %MissionInfoObject.desc0 = "This mission has no description.";
   }
   else
   {
      // there is no missioninfo object, so just return some
      // generic data for this mission
      %MissionInfoObject = new ScriptObject();
      %MissionInfoObject.name = %missionFile;
      %MissionInfoObject.desc0 = "This mission has no description.";
   }

   return %MissionInfoObject;
}
