//brick.cs
//this contains the generic brick deploying projectile 

datablock AudioProfile(brickMoveSound)
{
   filename    = "~/data/sound/clickMove.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(brickPlantSound)
{
   filename    = "~/data/sound/clickPlant.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(brickRotateSound)
{
   filename    = "~/data/sound/clickRotate.wav";
   description = AudioClosest3d;
   preload = true;
};


datablock AudioProfile(brickExplosionSound)
{
   filename    = "~/data/sound/breakBrick.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(brickTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 400;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "~/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "1 1 1 0.5";
	colors[1]	= "0 0 1 0.8";
	colors[2]	= "1 1 1 0.0";
	sizes[0]	= 0.1;
	sizes[1]	= 0.3;
	sizes[2]	= 0.01;
	times[0]	= 0.0;
	times[1]	= 0.3;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(brickTrailEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = brickTrailParticle;
};

//effects
datablock ParticleData(brickExplosionParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = 0.1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "~/data/particles/chunk";
	spinSpeed		= 100.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	useInvAlpha = false;
	colors[0]     = "0.9 0.9 0.7 1.0";
	colors[1]     = "0.9 0.9 0.7 0.0";
	sizes[0]      = 0.4;
	sizes[1]      = 0.0;
};

datablock ParticleEmitterData(brickExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.2;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "brickExplosionParticle";
};

datablock ExplosionData(brickExplosion)
{
   //explosionShape = "";
	soundProfile = brickExplosionSound;

   lifeTimeMS = 550;

   particleEmitter = brickExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};

datablock ExplosionData(brickDeployExplosion)
{
	//explosionShape = "";
	lifeTimeMS = 300;

	//particleEmitter = swordExplosionEmitter;
	//particleDensity = 10;
	//particleRadius = 0.2;

	faceViewer     = true;
	explosionScale = "1 1 1";

	shakeCamera = false;
	camShakeFreq = "20.0 22.0 20.0";
	camShakeAmp = "1.0 1.0 1.0";
	camShakeDuration = 0.5;
	camShakeRadius = 10.0;

	// Dynamic light
	lightStartRadius = 0;
	lightEndRadius = 3;
	lightStartColor = "1 1 1";
	lightEndColor = "0 0 0";
};

//projectile
datablock ProjectileData(brickDeployProjectile)
{
	//projectileShapeName = "~/data/shapes/arrow.dts";
	directDamage        = 10;
	radiusDamage        = 10;
	damageRadius        = 0.5;
	explosion           = brickDeployExplosion;
	particleEmitter     = brickTrailEmitter;

	muzzleVelocity      = 100;
	velInheritFactor    = 0.0;

	armingDelay         = 0;
	lifetime            = 500;
	fadeDelay           = 70;
	bounceElasticity    = 0;
	bounceFriction      = 0;
	isBallistic         = false;
	gravityMod = 0.0;

	hasLight    = false;
	lightRadius = 3.0;
	lightColor  = "0 0 0.5";
};


function brickDeployProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	//messageall(type, 'projectile collision col = %1', %col.getDataBlock().classname $= "baseplate");
	//messageall(type, 'projectile collision col = %1', %col);
	//messageall(type, 'projectile collision player = %1', %obj.client.player);

    if(%col.getClassname() !$= "StaticShape")  //Kill the mofo if we aren't going anywhere
		return;

	%player = %obj.client.player;
    %client = %obj.client;
	//if theres no player, (or client) bail out now
	if(!%player)
		return;

	%image = %player.getMountedImage(0);	//the thing the guy is holding
	%static = %client.currentPiece;
 
	%ghost = %client.currentPiece;


	//if there's no ghost, the guy switched or dropped guns or maybe died, so bail out
	if(%ghost $= ""){
		error("No ghost brick found");
		return;
	}
    
	%colData = %col.getDataBlock();
	%className = %colData.classname;

	if((%className $= "baseplate") || (%className $= "Block") ){
		//we've hit a baseplate
		//deploy the temporary brick based on what image the player is holding
		%baseplate = %col;
		%baseplateTrans = %baseplate.getTransform();
		%target = %pos;

		%targetX = getword(%target, 0);
		%targetY = getword(%target, 1);
		%targetZ = getword(%target, 2);

		%baseplateX = getword(%baseplateTrans, 0);
		%baseplateY = getword(%baseplateTrans, 1);
		%baseplateZ = getword(%baseplateTrans, 2);

		%xDiff = %targetX - %baseplateX;
		%yDiff = %targetY - %baseplateY;
		%zDiff = %targetZ - %baseplateZ;
		
        //This baby right here eliminates the need for a .z variable on the brick's datablock (unless we need it)
        if(%colData.z > 0)
        %colz = %baseplatez + (%colData.z*0.2);
        else
        %colz = getWord(%col.getWorldBox(),5);

		//round to the nearest 0.5
		%deployX = %baseplateX + (mFloor(%xDiff * 2 ) / 2);
		%deployY = %baseplateY + (mFloor(%yDiff * 2 ) / 2);
		%deployZ = round(%colz);
		
		%d = new StaticShape()
		{
			datablock = %ghost;
		};
        if(%client.bricktrans && %colData.canTrans)
        %d.setTrans(%client.bricktrans);
        %d.setskinname('ghostyellow');
        %d.setAbsoluteRotation("0 0 1" SPC %rotation, %deployX @ " " @ %deployY @ " " @ %deployZ);
        %d.ownerIP = %client.getRawIP();
        
		MissionCleanup.add(%d);

		//remove the players old temp brick if he has one
		if(%player.tempBrick)
			%player.tempBrick.delete();
		%player.tempBrick = %d;
	}

}

////////////////////////////////////////////////////////

function BrickImage::onMount(%this,%obj,%slot)
{
   // Images assume a false ammo state on load.  We need to
   // set the state according to the current inventory.

	//fixArmReady(%obj);
	if(%this.armReady)
	{
		if(%obj.getMountedImage($LeftHandSlot))
		{
			if(%obj.getMountedImage($LeftHandSlot).armReady)
				%obj.playthread(1, armReadyBoth);
			else
				%obj.playthread(1, armReadyRight);
		}
		else
		{
			%obj.playthread(1, armReadyRight);
		}
	}

	if(%this.ammo)	//dont check ammo if the image doesnt use ammo
	{
		if (%obj.getInventory(%this.ammo))
		%obj.setImageAmmo(%slot,true);
	}
	else
	{
		%obj.setImageAmmo(%slot,true);
	}
}

function BrickImage::onUnmount(%this,%obj,%slot)
{
	%obj.playthread(2, root);	//stop arm swinging 

	%leftimage = %obj.getmountedimage($lefthandslot);

	if(%leftimage)
	{
		if(%leftimage.armready)
		{
			%obj.playthread(1, armreadyleft);
			return;
		}
	}
	%obj.playthread(1, root);
    if(%obj.client.settingcolor == false) {
        if(isObject(%obj.tempBrick))
    	{
    		%obj.tempBrick.delete();
    		%obj.tempBrick = "";
    	}
    }
}
//////////////////////////START PARENT CLASS///////////////////////////////
datablock ItemData(brick)
{
	category = "BrickItems";  // Mission editor category
	className = "BrickItem"; // For inventory system

	 // Basic Item Properties
	shapeFile = "~/data/shapes/bricks/brick2x2.dts";
	scale = "2 2 3";

	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;
	rotate = false;
    mountpoint = 0;

	 // Dynamic properties defined by the scripts
	pickUpName = 'a brick';
	invName = 'brick';
	image = brickImage;
};

//static shape
datablock StaticShapeData(staticBrick)
{
	category = "Bricks";  // Mission editor category
	className = "Block";
	shapeFile = "~/data/shapes/bricks/brick2x2.dts";
    brick = true;
	//lego scale dimensions
	//x = 2;
	//y = 2;
	//z = 3;	//3 plates = 1 brick

    canTrans = true;

	boxX = -1;
	maxDamage = 800;
	destroyedLevel = 800;
	disabledLevel = 600;
	explosion  = brickExplosion;
	expDmgRadius = 8.0;
	expDamage = 0.35;
	expImpulse = 500.0;
	isShielded = true;
	energyPerDamagePoint = 110;
	maxEnergy = 50;
	rechargeRate = 0.20;
	renderWhenDestroyed = false;
	doesRepair = true;
	deployedObject = true;
    cloakTexture = "core/data/specialfx/cloaktexture.png";
};


//image
datablock ShapeBaseImageData(brickImage)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/bricks/brickWeapon.dts";
   emap = false;
   cloakable = false;
   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0.05 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = brick;
   ammo = " ";
   projectile = brickDeployProjectile;
   projectileType = Projectile;

   melee = false;
   armReady = true;

	stateName[0]                     = "Ready";
	stateTransitionOnTriggerDown[0]  = "Fire";
	stateAllowImageChange[0]         = true;

	stateName[1]			= "Fire";
	stateScript[1]                  = "onFire";
	stateFire[1]			= true;
	stateAllowImageChange[1]        = false;
	stateTimeoutValue[1]            = 0.5;
	stateTransitionOnTimeout[1]     = "Ready";

};
//////////////////////////END PARENT CLASS///////////////////////////////

//Baseplate
datablock StaticShapeData(gray32)
{
	category = "Baseplates";  // Mission editor category
	className = "baseplate";

	shapeFile = "~/data/shapes/bricks/baseplate32.dts";

	//lego scale dimensions
	x = 32;
	y = 32;
	z = 1;		//1 plate height (1/3 of a brick)

	deployedObject = true;
};

function serverCmdToggleBrickGun(%client) {
    if (%client.player.getmountedimage(0)==nametoid(brickImage))
      %client.player.unmountimage(0);
  else {
    %client.player.mountimage(brickImage,$RightHandSlot,$RightHandMount,$legocolor[%client.paintcolor]);
    messageClient(%client, 'MsgHilightInv', '', -1);
    %client.player.currWeaponSlot = -1;
    }
}

function servercmdselectBrick(%client,%brick) {
%client.currentPiece = "static"@%brick;
if(isObject(%client.player.tempbrick))
%client.player.tempbrick.setDatablock(%client.currentPiece);
}

//////////////////////////////
//////////Slates//////////////
//////////////////////////////
datablock StaticShapeData(staticSlate1x2 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/slate1x2.dts";
	//x = 1;	y = 2;	z = 1;
};
datablock StaticShapeData(staticSlate1x4 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/slate1x4.dts";
	//x = 1;	y = 4;	z = 1;
};
datablock StaticShapeData(staticSlate2x2 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/slate2x2.dts";
	//x = 2;	y = 2;	z = 1;
};

//////////////////////////////
//////////Plates//////////////
//////////////////////////////
datablock StaticShapeData(staticPlate1x1 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/plate1x1.dts";
	//x = 1;	y = 1;	z = 1;
};
datablock StaticShapeData(staticPlate1x2 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/plate1x2.dts";
	//x = 1;	y = 2;	z = 1;
};
datablock StaticShapeData(staticPlate1x3 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/plate1x3.dts";
	//x = 1;	y = 3;	z = 1;
};
datablock StaticShapeData(staticPlate1x4 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/plate1x4.dts";
	//x = 1;	y = 4;	z = 1;
};
datablock StaticShapeData(staticPlate1x6 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/plate1x6.dts";
	//x = 1;	y = 6;	z = 1;
};
datablock StaticShapeData(staticPlate1x8 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/plate1x8.dts";
	//x = 1;	y = 8;	z = 1;
};
datablock StaticShapeData(staticPlate1x10 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/plate1x10.dts";
	//x = 1;	y = 10;	z = 1;
};
datablock StaticShapeData(staticPlate1x12 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/plate1x12.dts";
	//x = 1;	y = 12;	z = 1;
};
datablock StaticShapeData(staticPlate2x2 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/plate2x2.dts";
	//x = 2;	y = 2;	z = 1;
};
datablock StaticShapeData(staticPlate2x3 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/plate2x3.dts";
	//x = 2;	y = 3;	z = 1;
};
datablock StaticShapeData(staticPlate2x4 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/plate2x4.dts";
	//x = 2;	y = 4;	z = 1;
};
datablock StaticShapeData(staticPlate6x12 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/plate6x12.dts";
	//x = 6;	y = 12;	z = 1;
};

//////////////////////////////
//////////Bricks//////////////
//////////////////////////////
datablock StaticShapeData(staticBrick1x1 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/brick1x1.dts";
	//x = 1;	y = 1;	z = 3;
};
datablock StaticShapeData(staticBrick1x2 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/brick1x2.dts";
	//x = 1;	y = 2;	z = 3;
};
datablock StaticShapeData(staticBrick1x3 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/brick1x3.dts";
	//x = 1;	y = 3;	z = 3;
};
datablock StaticShapeData(staticBrick1x4 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/brick1x4.dts";
	//x = 1;	y = 4;	z = 3;
};
datablock StaticShapeData(staticBrick1x6 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/brick1x6.dts";
	//x = 1;	y = 6;	z = 3;
};
datablock StaticShapeData(staticBrick1x8 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/brick1x8.dts";
	//x = 1;	y = 8;	z = 3;
};
datablock StaticShapeData(staticBrick1x10 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/brick1x10.dts";
	//x = 1;	y = 10;	z = 3;
};
datablock StaticShapeData(staticBrick1x12 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/brick1x12.dts";
	//x = 1;	y = 12;	z = 3;
};
datablock StaticShapeData(staticBrick1x16 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/brick1x16.dts";
	//x = 1;	y = 16;	z = 3;
};
datablock StaticShapeData(staticBrick2x2 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/brick2x2.dts";
	//x = 2;	y = 2;	z = 3;
};
datablock StaticShapeData(staticBrick2x3 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/brick2x3.dts";
	//x = 2;	y = 3;	z = 3;
};
datablock StaticShapeData(staticBrick2x4 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/brick2x4.dts";
	//x = 2;	y = 4;	z = 3;
};

datablock StaticShapeData(staticBrick1x1x5 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/brick1x1x5.dts";
	//x = 1;	y = 1;	z = 15;
};
datablock StaticShapeData(staticBrick1x2x5 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/brick1x2x5.dts";
	//x = 1;	y = 2;	z = 15;
};

//////////////////////////////
//////////Slopes//////////////
//////////////////////////////
datablock StaticShapeData(staticslope2x2 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/slope2x2.dts";
	//x = 1;	y = 2;	z = 15;
};

//////////////////////////////
////////Inv. Slopes///////////
//////////////////////////////


//////////////////////////////
//////////Windows/////////////
//////////////////////////////
datablock StaticShapeData(staticwindow1x4x5 : staticBrick) {
	shapeFile = "~/data/shapes/bricks/window1x4x5.dts";
	//x = 1;	y = 4;	z = 15;
    canTrans = false; // We don't want a window to be transed
};

//////////////////////////////
////////////Etc.//////////////
//////////////////////////////
datablock StaticShapeData(staticBrick1x1round : staticBrick) {
	shapeFile = "~/data/shapes/bricks/Brick1x1round.dts";
	//x = 1;	y = 1;	z = 3;
    z = 3;
};

//////////////////////////////
///////////Prints/////////////
//////////////////////////////
datablock ItemData(print2x2)
{
	category = "Item";  // Mission editor category

	equipment = true;	//for gui messages

	 // Basic Item Properties
	shapeFile = "~/data/shapes/bricks/prints/print2x2.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;

	 // Dynamic properties defined by the scripts
	pickUpName = 'a quiver';
	invName = 'Quiver';
	image = print2x2image;
};
datablock ShapeBaseImageData(print2x2image) {
	shapeFile = "~/data/shapes/bricks/prints/print2x2.dts";
    offSet = "0 0 0.201";
    className = "ItemImage";
    mountpoint = 0;
};

function startglow(%brick) {
if(!isObject(%brick)) {

return;
}
if(%brick.transbounce == -1)
%brick.setTrans(%brick.getTrans() - 0.01);
else
%brick.settrans(%brick.getTrans() + 0.01);
if(%brick.gettrans() >= 0.8)
%brick.transbounce = -1;
else if(%brick.gettrans() <= 0.6)
%brick.transbounce = 1;
%brick.schedule = schedule(10,0,"startglow",%brick);
}

function printBrick(%client,%brick) {
    if(%client.brickprint == -1)
    %client.brickprint = addtaggedstring("base");
    
    %brick.mountImage(print2x2image,0,0,%client.brickprint);
}

