//-----------------------------------------------------------------------------
// #Knex.cs
// Contains all code needed to use knex pieces minus a few hooks in a few
// other locations.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Datablocks
//-----------------------------------------------------------------------------

// Base Knex Part
datablock StaticShapeData(staticrodgreen) {
	
 	category = "K'NEX";  // Mission editor category
	className = "Knex";
	shapeFile = "~/data/shapes/knex/rodgreen.dts";
    toyPiece = true;

    canTrans = true;

	boxX = -1;
	maxDamage = 800;
	destroyedLevel = 800;
	disabledLevel = 600;
	explosion  = brickExplosion;
	expDmgRadius = 8.0;
	expDamage = 0.35;
	expImpulse = 500.0;
	isShielded = true;
	energyPerDamagePoint = 110;
	maxEnergy = 50;
	rechargeRate = 0.20;
	renderWhenDestroyed = false;
	doesRepair = true;
	deployedObject = true;
    cloakTexture = "core/data/specialfx/cloaktexture.png";
    
    //Extra Knex stuff from here on
    Ktype = "rod";
    
};

//////////////////////////////
/////////////Rods/////////////
//////////////////////////////
//datablock StaticShapeData(staticrodgreen : staticBrick) {
//	shapeFile = "~/data/shapes/knex/rodgreen.dts";
//};
datablock StaticShapeData(staticrodwhite : staticrodgreen) {
	shapeFile = "~/data/shapes/knex/rodwhite.dts";
};
datablock StaticShapeData(staticrodblue : staticrodgreen) {
	shapeFile = "~/data/shapes/knex/rodblue.dts";
};
datablock StaticShapeData(staticrodyellow : staticrodgreen) {
	shapeFile = "~/data/shapes/knex/rodyellow.dts";
    slot[1] = true;
    slot[2] = true;
};
datablock StaticShapeData(staticrodred : staticrodgreen) {
	shapeFile = "~/data/shapes/knex/rodred.dts";
};
datablock StaticShapeData(staticrodgrey : staticrodgreen) {
	shapeFile = "~/data/shapes/knex/rodgrey.dts";
};

//////////////////////////////
//////////Connectors//////////
//////////////////////////////
datablock StaticShapeData(staticConnectgrey : staticrodgreen) {
	shapeFile = "~/data/shapes/knex/Connectgrey.dts";
    Ktype = "connector";
    slot[1] = true;
};
datablock StaticShapeData(staticConnectlightgrey : staticrodgreen) {
	shapeFile = "~/data/shapes/knex/Connectlightgrey.dts";
    Ktype = "connector";
    slot[1] = true;
    slot[2] = true;
};
datablock StaticShapeData(staticConnectred : staticrodgreen) {
	shapeFile = "~/data/shapes/knex/Connectred.dts";
    Ktype = "connector";
    slot[1] = true;
    slot[2] = true;
    slot[3] = true;
};
datablock StaticShapeData(staticConnectgreen : staticrodgreen) {
	shapeFile = "~/data/shapes/knex/Connectgreen.dts";
    Ktype = "connector";
    slot[1] = true;
    slot[2] = true;
    slot[3] = true;
    slot[4] = true;
};
datablock StaticShapeData(staticConnectyellow : staticrodgreen) {
	shapeFile = "~/data/shapes/knex/Connectyellow.dts";
    Ktype = "connector";
    slot[1] = true;
    slot[2] = true;
    slot[3] = true;
    slot[4] = true;
    slot[5] = true;
};
datablock StaticShapeData(staticConnectwhite : staticrodgreen) {
	shapeFile = "~/data/shapes/knex/Connectwhite.dts";
    Ktype = "connector";
    slot[1] = true;
    slot[2] = true;
    slot[3] = true;
    slot[4] = true;
    slot[5] = true;
    slot[6] = true;
    slot[7] = true;
    slot[8] = true;
};

//////////////////////////////
//////Special Connectors//////
//////////////////////////////
datablock StaticShapeData(staticConnectPurple : staticrodgreen) {
	shapeFile = "~/data/shapes/knex/Connectpurple.dts";
    Ktype = "sconnector";
    slot[1] = true;
    slot[2] = true;
    slot[3] = true;
    slot[4] = true;
};
datablock StaticShapeData(staticConnectBlue : staticrodgreen) {
	shapeFile = "~/data/shapes/knex/Connectblue.dts";
    Ktype = "sconnector";
    slot[1] = true;
    slot[2] = true;
    slot[3] = true;
    slot[4] = true;
    slot[5] = true;
    slot[6] = true;
    slot[7] = true;
    slot[8] = true;
};

//-----------------------------------------------------------------------------
// Support Functions
//-----------------------------------------------------------------------------

// Set up our initial Knex piece placement
function placeTempKnex(%obj,%col,%fade,%pos,%normal)
{
    // Get colliding object's type, and if it's a Knex piece
    // we'll get its name so we can determine where we can
    // place a new part.
    
    %client = %obj.client;
    %player = %client.player;
    if(%player.tempBrick)
        %player.tempBrick.delete();
        
    %colKtype = %col.dataBlock.Ktype;
    %tempKnexdb = %client.currentPiece;
    if(%tempKnexdb.Ktype $= %colKtype)
        return; // <-- Rods can't connect to rods, and connectors blah..you get it

    //code here
    %colName = %col.dataBlock.getName();

    %k = new StaticShape()
		{
			datablock = %client.currentPiece;
    };
    %player.tempbrick = %k;
    %k.colKnex = %col;
    %k.currslot = 1;

    %slot = %k.currslot;
    shiftKnex(%client);
    
    // If we found a spot(s), choose the one closest to the spot
    // we shot at.
    
    //code here
    
    //gahhhhhhhhhhhhh!!!!!!!!!!!!!!

}

// Rotates thru available slots for the Knex piece we want placed
function shiftKnex(%client,%shift)
{
    %knexpiece = %client.player.tempbrick;
    %colPiece = %knexpiece.colKnex;

    %slot = %knexpiece.currslot+%shift;

    while(%colPiece.dataBlock.slot[%i++] == true)
        %lastslot = %i;

    if(%slot <= 0)
        %slot = %knexpiece.currslot = %lastslot;
    else if(%slot > %lastslot)
        %slot = %knexpiece.currslot = 1;
    else
        %knexpiece.currslot = %slot;
    echo("Slot: "@%slot);
    %connectingslot = %knexpiece.connectslot = 5;
    %rot = matrixToEuler(%colPiece.rotation);
    %slotTransform = getWords(%colpiece.getNodeTransform("mount"@%slot),0,2);
    //%knexpiece.setTransformFromNode("mount"@%connectingslot,%slotTransform);
    %knexpiece.setRotFromPoint(%rot,%slottransform);
}

function ShapeBase::add_euler_Rot(%this,%x,%y,%z)
{
%transform = getwords(%this.gettransform(), 0, 2) @
MatrixMultiply(getwords(%this.gettransform(), 3, 6),
getWords(MatrixCreateFromEuler(%x SPC %y SPC %z),3,6));
echo(%transform);
%this.settransform(%transform);
}

function ShapeBase::set_euler_rot(%this,%x,%y,%z)
{
    %transform = getWords(%this.getTransform(), 0, 2) SPC getWords(MatrixCreateFromEuler(%x SPC %y SPC %z),3,6);
    echo(%transform);
    %this.setTransform(%transform);
}

function plantKnex(%client)
{
    %ghost = %client.currentPiece;
    %tempbrick = %client.player.tempbrick;
    
    %d = new StaticShape()
		{
			datablock = %ghost;
    };
    %d.setTransform(%client.player.tempbrick.getTransform());
    
    %tempbrick.colKnex.slottaken[%tempbrick.currslot] = true;
}

function degToRad(%degree)
{
    return (360 - %degree)/180*$pi;
}

function rotRetain(%rot)
{
    if(%rot < 0) {
        while(%rot < 360)
         %rot+=360;
    }
    else if(%rot > 360) {
       while(%rot > 0)
        %rot-=360;
    }
    return %rot;
}
// %obj.setTransformFromPoint("0 45 0",mount1.position); <-- pseudo-code
function ShapeBase::setRotFromPoint(%this,%rot,%point)
{
    %thetaX = degToRad(getWord(%rot,0));
    %thetaY = degToRad(getWord(%rot,1));
    %thetaZ = degToRad(getWord(%rot,2));
    %pos = vectoradd(%this.position ,vectorscale(%point, -1));
    %rx = getWord(%pos,0);
    %ry = getWord(%pos,1);
    %rz = getWord(%pos,2);
    %newpos = %rx * mcos(%thetaX) - %ry * msin(%thetaY);
    %newpos = %newpos SPC %rx * msin(%thetaY) + %ry * mcos(%thetaY);
    %newpos = %newpos SPC %rz;
    %newpos = vectoradd(%newpos, %point);
    %newRotation = rotaddup(%this.rotation,%rot);
    
    %this.setTransform(%newPos SPC rotConv(%newRotation));
    
}

function ShapeBase::setTransformFromNode(%this,%node,%transform)
{
    %objtransform = %this.getTransform();
    %nodetransform = %this.getNodetransform(%node);
    //echo(%objtransform);
    //echo(%nodetransform);
    %objx = getWord(%objtransform,0);
    %objy = getWord(%objtransform,1);
    %objz = getWord(%objtransform,2);
    
    %nodeX = getWord(%nodetransform,0);
    %nodeY = getWord(%nodetransform,1);
    %nodeZ = getWord(%nodetransform,2);
    
    %offsetX = %objx - %nodeX;
    %offsetY = %objy - %nodeY;
    %offsetZ = %objz - %nodeZ;
    //echo(%offsetX SPC %offsetY SPC %offsetZ);
    %newTransformX = getWord(%transform,0) - %offsetX;
    %newTransformY = getWord(%transform,1) - %offsetY;
    %newTransformZ = getWord(%transform,2) - %offsetZ;
    
    %newTransform = %newtransformX SPC %newtransformY SPC %newtransformZ;

    %this.setTransform(%newtransform);
}



