//save.cs
$Save::Version = "0.2";
//Hybrid Save/Load system for TBG

function saveBuild(%name) {
    %mission = strreplace(filename($Server::MissionFile),".mis","");
    %filename = "core/saves/"@%mission@"/"@%name@".save";
    %file = new FileObject();
	%file.openForWrite(%filename);
    %file.writeLine("//------------------------------ Version "@$Save::Version@" ------------------------------");
   	for (%i = 0; %i < MissionGroup.getCount(); %i++)
    {
		%object = MissionGroup.getObject(%i);
        if(%object.dataBlock !$= "" && %object.dataBlock $= "gray32")
        %file.writeLine(saveObject(%object));
    }

    %count = MissionCleanup.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%object = MissionCleanup.getObject(%i);
        if(%object.dataBlock !$= "" && %object.dataBlock.classname $= "block") {
        %file.writeLine(saveObject(%object));
        //echo("Object Saved: "@%object);
        }
    }
    
    %file.close();
    %file.delete();
    echo("Objects saved to: "@%filename);
    MessageAll('msgObjectsSaved',"\c2Objects have been saved.");
    setmodpaths(getmodpaths()); // load the file into Torque's filelist.

}

function loadBuild(%name) {
    %mission = strreplace(filename($Server::MissionFile),".mis","");
    %name = "core/saves/"@%mission@"/"@%name@".save";
    %file = new FileObject();
	%file.openForRead(%name);
     for (%i = 0; %i < MissionGroup.getCount(); %i++)
    {
		%object = MissionGroup.getObject(%i);
        if(%object.dataBlock $= "gray32")
        %object.delete();
    }
    while(!%file.isEOF()) {
        %string = %file.readline();
        if(getSubstr(%string,0,1) $= "/")
        continue;
        schedule(%i++,0,"loadobject",%string);
    }
    MessageAll('msgObjectsLoaded',"\c2Objects are being loaded.");

}

function saveObject(%object) {

    //Ex: -27.5 42.5 23.2 1 0 0 01 1 1 staticSlate2x2 base 1
    %string = getWords(%object.getTransform(),0,7); // get the object's position and begin the string (0-8)
    %string = %string SPC %object.getScale(); // get the object's scale (9-11)
    %string = %string SPC %object.dataBlock; //add the datablock name (12)
    if(%object.getSkinname() !$= "")
    %string = %string SPC %object.getSkinName(); // get the object's skinname (13)
    else
    %string = %string SPC "base";
    %string = %string SPC %object.getTrans(); // is the object transparent? (14)
    
    return %string;
}

function loadObject(%string) {
    //Ex: -27.5 42.5 23.2 1 0 0 01 1 1 staticSlate2x2 base 1
    %position = getWords(%string,0,2); //first 3 words
    %rotation = getWords(%string,3,6); //next 4 words
    %scale = getWords(%string,7,9); // next 3 words
    %datablock = getWord(%string,10);
    %skinname = getWord(%string,11);
    %trans = getWord(%string,12);

    %object = new StaticShape(){
				dataBlock = %datablock;
                };
    %object.setTransform(getWords(%string,0,7));
    %object.setScale(%scale);
    %object.setSkinName(%skinname);
    if(%trans != 1)
    %object.setTrans(%trans);
    if(%datablock $= "gray32")
    MissionGroup.add(%object);
    else
    MissionCleanup.add(%object);
}

function clearBricks() {
     for (%i = 0; %i < MissionCleanup.getCount(); %i++)
    {
		%object = MissionCleanup.getObject(%i);
        if(%object.dataBlock !$= "" && %object.getDatablock().classname $= "Block")
            %object.explode();
  }
}
