//selectorgun.cs
//Selector gun shoots out an object that on collision will select that object

/////////////
//PARTICLES//
/////////////
datablock ParticleData(selectorgunTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 200;
	lifetimeVarianceMS	= 50;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;

	textureName		= "core/data/particles/ring";

	// Interpolation variables
	colors[0]	= "0.5 0.5 0 0.500";
	sizes[0]	= 0.1;
	times[0]	= 0.0;
};


datablock ParticleData(selectorgunExplosionParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 200;
	textureName          = "core/data/particles/lbolt";
	useInvAlpha		= false;
	spinSpeed		= 100.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]	= "0.5 0.5 0 0.500";
	sizes[0]	= 0.1;
	times[0]	= 0.0;
};

////////////
//EMITTERS//
////////////
datablock ParticleEmitterData(selectorgunTrailEmitter)
{
	ejectionPeriodMS = 20;
	periodVarianceMS = 5;
	ejectionVelocity = 0.5;
	velocityVariance = 0.1;
	ejectionOffset   = 0.1;
	thetaMin         = 0.0;
	thetaMax         = 90.0;  
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = selectorgunTrailParticle;
};

datablock ParticleEmitterData(selectorgunExplosionEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 10;
   thetaMax         = 10;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = selectorgunExplosionParticle;
};

//////////////
//EXPLOSIONS//
//////////////
datablock ExplosionData(selectorgunExplosion)
{
   explosionShape = "core/data/shapes/bricks/brick1x1.dts";
   lifeTimeMS = 550;

   soundProfile = sprayHitSound;

   //particleEmitter = bluePaintExplosionEmitter;
  // particleDensity = 10;
  // particleRadius = 0.2;

   faceViewer     = false;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};

///////////////
//PROJECTILES//
///////////////
datablock ProjectileData(selectorgunProjectile)
{
   //projectileShapeName = "core/data/shapes/arrow.dts";
   explosion           = selectorgunExplosion;
   particleEmitter     = selectorgunTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 1000;
   fadeDelay           = 0;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};


/////////
//ITEMS//
/////////
datablock ItemData(selectorgun)
{
	category = "Weapon";  // Mission editor category
	className = "tool";   // For inventory system

	 // Basic Item Properties
	shapeFile = "core/data/shapes/spraycan.dts";
	cloaktexture = "core/data/specialfx/cloakTexture";
	skinName = "ghostyellow";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	 // Dynamic properties defined by the scripts
	pickUpName = 'a Selector Gun.';
	invName = 'Selector Gun';
	image = selectorgunImage;
};

//////////
//IMAGES//
//////////
datablock ShapeBaseImageData(selectorgunImage)
{
   // Basic Item properties
   shapeFile = "core/data/shapes/spraycan.dts";
   cloaktexture = "core/data/specialfx/cloakTexture";
   skinName = 'ghostyellow';
   emap = true;
    
   mountPoint = 0;
   offset = "0 0 0";

   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = selectorgun;
   ammo = " ";
   projectile = selectorgunProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.0;
	stateTransitionOnTimeout[0]       = "Ready";

	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	

	stateName[2]					= "Fire";
	stateScript[2]                  = "onFire";
	stateFire[2]					= true;
	stateAllowImageChange[2]        = true;
	stateTimeoutValue[2]            = 0.10;
	stateTransitionOnTimeout[2]     = "Fire";
	stateTransitionOnTriggerUp[2]	= "Ready";
	stateEmitter[2]					= selectorgunExplosionEmitter;
	stateEmitterTime[2]				= 0.1;

};

function selectorGunImage::onUnMount(%this,%obj,%slot)
{
   %obj.client.edit = 0;
   %obj.selectedObj.setSkinName(%client.player.selectedObjcolor);
   //%obj.selectedObj = "";
   //%obj.selectedObjcolor = "";
}

///////////
//METHODS//
///////////
//Collisions//
function selectorgunProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal) {
  if(%col.getType() == 67108869) //terrain type
	return;
  
	%client = %obj.client;
	%obj = %client.player;
  if (%client.edit && %col != %obj.selectedObj) {
    if (%col.getSkinname() $= 'ghostyellow' || %col.getdataBlock() $= "" ||
        (%col.ownerIP !$= %client.getRawIP() && !%client.isAdmin && !%client.isSuperAdmin)) {
      messageClient(%client, 'MsgBrickLimit', "\c3 Sorry but you may not select this object.");
      return;
      }
    messageClient(%client, 'MsgBrickLimit', "\c2"@%col.dataBlock@"\c3 has been selected");
    
    if (isobject(%obj.selectedObj))
      %obj.selectedObj.setskinname(%obj.selectedObjcolor);
      
    %obj.selectedObj=%col;
    %obj.selectedObjcolor=%col.getskinname();
    
    %obj.selectedObj.setSkinName('ghostyellow');
   }
}
function serverCmdtoggleEditGun(%client) 
{
   %player = %client.player;
   
         if (isobject(%player.selectedObj) && %client.edit)
         {
            %player.selectedObj.setskinname(%player.selectedObjcolor);
            //messageClient(%client, 'Msg', "\c2You are in \c3NORMAL\c2 mode.");
            %player.unmountimage($RightHandMount);
            %client.edit = 0;
            return;
         }
         else if (%player.getmountedimage(0)==nametoid(selectorgunImage) && %client.edit) {
            //messageClient(%client, 'MsgHilightInv', '', -1);
            %player.unmountimage($RightHandMount);
            %player.selectedObj.setSkinName(%player.selectedObjColor);
            %client.edit = 0;
            return;
         }
         else if (%player.getmountedimage(0)!=nametoid(selectorgunImage) && !%client.edit) {
            //messageClient(%client, 'MsgHilightInv', '', -1);
            %player.currWeaponSlot = -1;
            %player.mountimage(selectorgunImage,$RightHandSlot,$RightHandMount,getTaggedString('ghostyellow'));
            %client.edit=1;
            //messageClient(%client, 'Msg', "\c2You are in \c3EDIT\c2 mode.");
            if (isobject(%player.selectedObj)) {
               %player.selectedObj.setSkinName('ghostyellow');
               messageClient(%client, 'Msg', "\c2Warning! You have \c3"@%player.selectedObj.dataBlock@"\c2 selected.");
               %player.selectedObjcolor=%player.selectedObj.getskinname();
            }
            if(%client.player.tempBrick) {
               %client.player.tempBrick.delete();
               %client.player.tempBrick = "";
            } 
      }
}