//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Hook into the mission editor.

function StaticShapeData::create(%data)
{
   // The mission editor invokes this method when it wants to create
   // an object of the given datablock type.
   %obj = new StaticShape() {
      dataBlock = %data;
   };
   return %obj;
}


function StaticShapeData::onAdd(%this, %obj)
{
	 %obj.setSkinName(%this.skinName);
}


function StaticShapeData::damage(%this, %obj, %sourceObject, %position, %damage, %damageType)
{
	%obj.setDamageLevel(%obj.getDamageLevel() + (%damage));

	if(%obj.getDamageLevel() >= %this.maxDamage)
	{	
		%obj.team.count[%this.pack] -= 1;
		%trans = %obj.getTransform();
		%exp = new (explosion)()
		{
			datablock = %this.explosion;
		};
		MissionCleanUp.add(%exp);
		%exp.setTransform(%trans);
		%obj.setTransform("0 0 -999");
		%obj.delete();
	}
}


function StaticShape::Explode(%obj)
{
	%obj.setDamageState(destroyed);
	
	if(%obj.emitter)
	   %obj.emitter.delete();
   if(%obj.light)
      %obj.light.delete();
	
    %obj.delete();
    return;

	%pos = %obj.getWorldBoxCenter();

	//%exp = new (explosion)()
	//{
	//	datablock = spearExplosion;
	//	initialPosition = %pos;
	//};
	//%exp.setTransform(%pos);
	//%obj.setTransform("0 0 -999");
    //%blowupVehicle = new WheeledVehicle()
	//{
	//	dataBlock = explodeVehicle;
	//	initialPosition = %pos;
	//};
    //%blowupvehicle.setTransform(%pos);
    //%randomVector = getrandom(10)-5 SPC getrandom(10)-5 SPC getrandom(10)-5;
    //%blowupVehicle.applyImpulse(%position, %randomVector);
    //%blowupVehicle.mountObject(%obj,0);


	serverplay3D(brickExplosionSound, %obj.getWorldBoxCenter());
    //%obj.startFade(1000,2000,false);
	//%obj.schedule(2000, delete);
    //%blowupVehicle.schedule(2010, delete);
	//MissionCleanUp.add(%blowupVehicle);
}
